import 'package:agent_example/ft_tracing_custom_dio.dart';
import 'package:agent_example/ft_tracing_custom_http.dart';
import 'package:dio/dio.dart';
import 'package:flutter/material.dart';
import 'package:ft_mobile_agent_flutter/ft_mobile_agent_flutter.dart';
import 'package:http/io_client.dart';

const String requestUrl =
    "http://testing-ft2x-api.cloudcare.cn/api/v1/account/permissions";

class CustomTracing extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("网络链路追踪(手动)"),
      ),
      body: Column(
        children: <Widget>[
          ListTile(
            title: Text("http"),
            onTap: () async {
              final client = FTTracingHttpClient();
              var response = await client.get(Uri.parse(requestUrl));
              FTLogger().logging(response.body, FTLogStatus.info);
            },
          ),
          ListTile(
            title: Text("dio"),
            onTap: () {
              dioGetHttp();
            },
          ),
        ],
      ),
    );
  }

  void dioGetHttp() async {
    try {
      var dio = Dio();
      dio.interceptors.add(new FTInterceptor());
      var response = await dio.get(requestUrl);
      print(response);
    } catch (e) {
      print(e);
    }
  }
}

class AutoTracing extends StatelessWidget {
  final client = IOClient();
  final dio = Dio();

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text("网络链路追踪(自动)")),
      body: Column(
        children: <Widget>[
          ListTile(
            title: Text("http"),
            onTap: () async {
              var response = await client.get(Uri.parse(requestUrl));
              print(response);
            },
          ),
          ListTile(
            title: Text("dio"),
            onTap: () async {
              var response = await dio.get(requestUrl);
              print(response);
            },
          ),
        ],
      ),
    );
  }
}
